import {select, arc, json , geoPath , geoMercator, geoOrthographic, geoStereographic, 
        geoNaturalEarth1} from 'd3';
import {feature } from 'topojson';

const svg = d3.select("svg");


//const projection = geoMercator();
//const projection = geoOrthographic();
//const projection = geoStereographic();
const projection = geoNaturalEarth1();


const pathGenerator = geoPath().projection(projection);
svg.append('path')
			.attr('class', 'globe')
			.attr('d', pathGenerator({type: 'Sphere'}))
json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
	.then(data => {
  const countries = feature(data, data.objects.countries);

  const paths=svg.selectAll('path').data(countries.features);
  paths.enter().append('path')
    .attr('class', 'country')
    .attr('d', d => pathGenerator(d))
});

/*
World Atlas data (countries-110m.json) is in TopoJSON format.
D3 geo libraries can work with GeoJSON.
Therefore the TopoJSON-data needs to be converted to GeoJSON
in order to generate svg-paths using D3.
This is done with the geoPath-library.

In this script two generator functions are created:
1. projection: generate map projection
2. pathGenerator: convert TopoJSON to GeoJSON, then project it using the projection

*/






